window.Gleam.initSearch([{"doc":"esgleam","title":"esgleam","content":"# esgleam\n\n[![Package Version](https://img.shields.io/hexpm/v/esgleam)](https://hex.pm/packages/esgleam)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/esgleam/)\n\n*esbuild for Gleam that works on Erlang &amp; JavaScript.*\n\n## Quick start\n\n1. Create a Gleam project as you would normally.\n\n2. Install `esbuild` (*note*: you will have to rerun this if your build directory gets wiped. i.e. after `gleam clean`)\n```sh\n$ gleam run -m esgleam/install\n```\n\n3. Create `/src/build.gleam` with the following\n```gleam\nimport esgleam\n\npub fn main() {\n   esgleam.new(&quot;./dist/static&quot;)\n   |&gt; esgleam.entry(&quot;main.gleam&quot;)\n   |&gt; esgleam.target(&quot;esnext&quot;)\n   |&gt; esgleam.target(&quot;firefox110&quot;)\n   |&gt; esgleam.bundle\n}\n```\n\n4. Build for JavaScript\n```sh\n$ gleam build --target=javascript\n```\n\n5. Run your build script (in any target)\n```sh\n$ gleam run -m build\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add esgleam\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/esgleam&gt;.\n\n## Roadmap\n- [ ] Create file watcher for `*.gleam` which runs on both Erlang and JavaScript\n- [ ] Fix bug with STDOUT/STDERR not being shown when running `esbuild` in the erlang target\n- [ ] Write tests for config options\n- [ ] Add more config options if needed\n- [ ] Pseudo-SourceMaps until [#1341](https://github.com/gleam-lang/gleam/discussions/1341) merges\n- [ ] Consider creating a way to use plugins\n- [ ] Hot Module Reloading?????\n","url":"index.html"},{"doc":"esgleam/install","title":"main","content":"pub fn main() -&gt; Nil\n Installs `esbuild` (required to be run before building)    \n Run with `gleam run -m esgleam/install`\nSynonyms:\nesgleam/install.main\nesgleam/install main","url":"esgleam/install.html#main"},{"doc":"esgleam/install","title":"esgleam/install","content":"","url":"esgleam/install.html"},{"doc":"esgleam","title":"Config","content":"pub type Config {\n  Config(\n    outdir: String,\n    entry_points: List(String),\n    format: Format,\n    minify: Bool,\n    target: List(String),\n    serve: Option(String),\n    sourcemap: Bool,\n    watch: Bool,\n    raw: String,\n  )\n}\n Config for esbuild\nConfig(\n  outdir: String,\n  entry_points: List(String),\n  format: Format,\n  minify: Bool,\n  target: List(String),\n  serve: Option(String),\n  sourcemap: Bool,\n  watch: Bool,\n  raw: String,\n)\n\noutdir\n&lt;p&gt;Output directory&lt;/p&gt;\n\nentry_points\n&lt;p&gt;List of entry points supplied&lt;/p&gt;\n\nformat\n&lt;p&gt;Output format for JavaScript. See &lt;a href=&quot;#Format&quot;&gt;&lt;code&gt;Format&lt;/code&gt;&lt;/a&gt;&lt;br /&gt;\ndefault &lt;code&gt;Esm&lt;/code&gt;&lt;/p&gt;\n\nminify\n&lt;p&gt;default &lt;code&gt;False&lt;/code&gt;&lt;/p&gt;\n\ntarget\n&lt;p&gt;List of &lt;a href=&quot;https://esbuild.github.io/api/#target&quot;&gt;target environments&lt;/a&gt;&lt;br /&gt;\ndefault &lt;code&gt;[]&lt;/code&gt;&lt;/p&gt;\n\nserve\n&lt;p&gt;The root directory for the dev server (run server when defined)&lt;br /&gt;\ndefault &lt;code&gt;None&lt;/code&gt;&lt;/p&gt;\n\nsourcemap\n&lt;p&gt;Generate sourcemap for JavaScript&lt;br /&gt;\ndefault &lt;code&gt;False&lt;/code&gt;&lt;/p&gt;\n\nwatch\n&lt;p&gt;Enable watchmode. Bundles files on change&lt;br /&gt;\nNote: &lt;code&gt;gleam build&lt;/code&gt; need to be run manually&lt;br /&gt;\ndefault &lt;code&gt;False&lt;/code&gt;&lt;/p&gt;\n\nraw\n&lt;p&gt;raw flags to pass to esbuild&lt;br /&gt;\ndefault &lt;code&gt;&amp;quot;&amp;quot;&lt;/code&gt;&lt;/p&gt;\n\nSynonyms:\nesgleam.Config\nesgleam Config","url":"esgleam.html#Config"},{"doc":"esgleam","title":"Format","content":"pub type Format {\n  Esm\n  Cjs\n  Iife\n}\n Output format of generated JavaScript\nEsm\n ECMAScript module\n\nCjs\n CommonJS\n\nIife\n immediately-invoked function expression\n\nSynonyms:\nesgleam.Format\nesgleam Format","url":"esgleam.html#Format"},{"doc":"esgleam","title":"bundle","content":"pub fn bundle(config: Config) -&gt; Result(Nil, FileError)\n\nSynonyms:\nesgleam.bundle\nesgleam bundle","url":"esgleam.html#bundle"},{"doc":"esgleam","title":"entry","content":"pub fn entry(config: Config, path: String) -&gt; Config\n [Entry points](https://esbuild.github.io/api/#entry-points)   \n Can be use multiple times\nSynonyms:\nesgleam.entry\nesgleam entry","url":"esgleam.html#entry"},{"doc":"esgleam","title":"format","content":"pub fn format(config: Config, format: Format) -&gt; Config\n Output format. see [`Format`](#format)\nSynonyms:\nesgleam.format\nesgleam format","url":"esgleam.html#format"},{"doc":"esgleam","title":"minify","content":"pub fn minify(config: Config, do_minify: Bool) -&gt; Config\n Create minified JavaScript\nSynonyms:\nesgleam.minify\nesgleam minify","url":"esgleam.html#minify"},{"doc":"esgleam","title":"new","content":"pub fn new(outdir path: String) -&gt; Config\n Start to create a build script   \n \n &gt; esbuild.new(&quot;./dist/static&quot;)\n Config(&quot;./dist/static&quot;, ...)\n \nSynonyms:\nesgleam.new\nesgleam new","url":"esgleam.html#new"},{"doc":"esgleam","title":"raw","content":"pub fn raw(config: Config, args: String) -&gt; Config\n Raw CLI argument to pass to esbuild\nSynonyms:\nesgleam.raw\nesgleam raw","url":"esgleam.html#raw"},{"doc":"esgleam","title":"serve","content":"pub fn serve(config: Config, dir path: String) -&gt; Config\n Start a development server on http://127.0.0.1:8000 with `path` being `/`\nSynonyms:\nesgleam.serve\nesgleam serve","url":"esgleam.html#serve"},{"doc":"esgleam","title":"target","content":"pub fn target(config: Config, target: String) -&gt; Config\n [Target](https://esbuild.github.io/api/#target) for transpiled JavaScript.\n Can be used mutiple times   \n \n &gt; esbuild.new(&quot;./dist/static&quot;)\n &gt; |&gt; esbuild.target(&quot;es2020&quot;)\n &gt; |&gt; esbuild.target(&quot;firefox110&quot;)\n &gt; |&gt; esbuild.target(&quot;edge90&quot;)\n \nSynonyms:\nesgleam.target\nesgleam target","url":"esgleam.html#target"},{"doc":"esgleam","title":"watch","content":"pub fn watch(config: Config, do_watch: Bool) -&gt; Config\n Note: There is no file watcher for Gleam files so you have to manually run `gleam build` on change.\nSynonyms:\nesgleam.watch\nesgleam watch","url":"esgleam.html#watch"},{"doc":"esgleam","title":"esgleam","content":"","url":"esgleam.html"}]);